<?php

function saveNewRevision($content, $teaser, $pageID) {

   global $xoopsDB, $xoopsModuleConfig;
   
   if ( getNumRevisionsForPage($pageID) >= $xoopsModuleConfig['mpu_conf_num_revisions'] )  {
      // delete old revision
      
      // find oldest revision for this page
      $oldestID = getOldestRevisionForPage($pageID);
      
      $qs = "DELETE FROM ".$xoopsDB->prefix('mpu_revision_log')."
             WHERE id=".(int)$oldestID;
      $xoopsDB->query($qs);
   }
   
   // add new revision
   $qs = "INSERT INTO ".$xoopsDB->prefix('mpu_revision_log')." (mpb_10_id, revisionDateTime, content, teaser)
          VALUES ('".(int)$pageID."', 
                    NOW(), 
                     '".mysql_real_escape_string(stripslashes($content))."', 
                      '".mysql_real_escape_string(stripslashes($teaser))."')";
   $xoopsDB->query($qs);
   
}


function restoreRevision($pageID, $revisionID) {

   global $xoopsDB;

   // get content and teaser from revision # $revisionID
   $qs = "SELECT content, teaser
          FROM ".$xoopsDB->prefix('mpu_revision_log')."
          WHERE id=".(int)$revisionID;
   $rs = $xoopsDB->query($qs);
   $contentArr = $xoopsDB->fetchArray($rs);

   // update mpu_mpb_mpublish
   $qs = "UPDATE ".$xoopsDB->prefix('mpu_mpb_mpublish')."
          SET mpb_35_conteudo='".mysql_real_escape_string($contentArr['content'])."',
               teaser='".mysql_real_escape_string($contentArr['teaser'])."'
          WHERE mpb_10_id=".(int)$pageID;
   $xoopsDB->query($qs);
   
   // update time on this revision
   $qs = "UPDATE ".$xoopsDB->prefix('mpu_revision_log')."
          SET revisionDateTime=NOW()
          WHERE id=".(int)$revisionID;
   $xoopsDB->query($qs);

}


function getOldestRevisionForPage($pageID) {

  global $xoopsDB;
  
  $qs = "SELECT id
         FROM ".$xoopsDB->prefix('mpu_revision_log')."
         WHERE mpb_10_id=".(int)$pageID."
         ORDER BY revisionDateTime ASC";
  $rs = $xoopsDB->query($qs);
  $arr = $xoopsDB->fetchArray($rs);
  
  return $arr['id'];

}


function getNumRevisionsForPage($pageID) {

  global $xoopsDB;
  
  $qs = "SELECT id
         FROM ".$xoopsDB->prefix('mpu_revision_log')."
         WHERE mpb_10_id=".(int)$pageID;
  $rs = $xoopsDB->query($qs);
  $numRows = $xoopsDB->getRowsNum($rs);

  return $numRows;

}


function getRevisions($pageID) {

  global $xoopsDB;
  
  $qs = "SELECT id, UNIX_TIMESTAMP(revisionDateTime) as revisionTimestamp 
         FROM ".$xoopsDB->prefix('mpu_revision_log')."
         WHERE mpb_10_id=".(int)$pageID."
         ORDER BY revisionDateTime ASC";
  $rs = $xoopsDB->query($qs);
  $arr = array(0=>'Select..');
  while ( $row = $xoopsDB->fetchArray($rs) ) {
      $arr[$row['id']] = date('n/j/Y g:i:s A', $row['revisionTimestamp']);     
  }       
  
  // delete last revision (it's the current one)
  array_pop($arr);
  
  return $arr;  

}


function getRevision($pageID, $revisionID) {

  global $xoopsDB;
  
  $qs = "SELECT teaser, content 
         FROM ".$xoopsDB->prefix('mpu_revision_log')."
         WHERE id=".(int)$revisionID;
  $rs = $xoopsDB->query($qs);
  $row = $xoopsDB->fetchArray($rs);
  
  return $row;

}


?>
